#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2015/05/22 10:37:34 +0900>
#
# Rubywavt@CǂݍŁAAǰpNۂbvVN
# wavefileAdxruby gpB

require "rubygems"
require "wavefile"
require "dxruby"

# wavt@Cw
IN_FILE = "input.wav"

# wavt@C̃TvOg
HZ_V = 48000

# 1bԂ̉f̃R}
FPS = 24

# ĂEĂȂ̔ʒlB01.0̊ԂŎwB
BOUNDARY = 0.1

# pN̕\
MOUTH_LIST = [ 2, 1, 2, 0, 1, 0, 2, 1, 0, 1, 2, 1]

SAMPLES_PER_BUFFER = HZ_V / FPS

# wavf[^ǂݍ

# :mono , :stereo
# :pcm_8, :pcm_16, :pcm_32, :float_32, :float_64
format = WaveFile::Format.new(:mono, :pcm_16, HZ_V)

reader = WaveFile::Reader.new(IN_FILE, format)
sumlist = []
begin
  while true do
    buffer = reader.read(SAMPLES_PER_BUFFER)

    # lUSĉZ
    sumv = 0
    buffer.samples.each do |v|
      sumv += (v > 0)? v : -v
    end
    sumlist.push(sumv)
  end
rescue EOFError
  reader.close
end

# ʂ01.0̊ԂŋL^
vmax = sumlist.max # z̍ől擾
vollist = sumlist.map { |v| (v.to_f / vmax.to_f) }

# wavt@CDXRubyōĐ邽߂ɁAʓrǂݍ
sound = Sound.new(IN_FILE)

# 摜ǂݍ
base = Image.load("img/base.png")
mouth = [
  Image.load("img/mouth0.png"),
  Image.load("img/mouth1.png"),
  Image.load("img/mouth2.png"),
]

Window.fps = FPS # t[[gw

count = 0
mouth_kind = 0
mouth_count = 0
mouth_index = 0

# C[v
Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  if count >= vollist.length
    # ĐI
    # break
    count = 0
  end

  # JE^0ȂATEhĐJn
  sound.play if count == 0

  # ʎ擾
  v = vollist[count]

  # ̎ނ߂
  mouth_count -= 1 if mouth_count > 0
  if mouth_count <= 0
    if v > BOUNDARY
      mouth_count = 3 # 3R}BӎăJE^ݒ
      mouth_kind = MOUTH_LIST[mouth_index]
      mouth_index = (mouth_index + 1) % MOUTH_LIST.length
    else
      mouth_kind = 0
    end
  end

  # `
  Window.draw(0, 0, base)
  Window.draw(0, 0, mouth[mouth_kind])

  # ʂ̑傫o[ŕ\
  x = Window.width * v
  Window.drawBoxFill(0, 0, x, 8, C_GREEN)

  count += 1
end
